/*
  Lauflicht aus 4 LEDs oder Relais
  von Norbert Kraemer
 */
 
// Variablendefinitionen
int index;
int led[] = { 2, 3, 4, 5 };  // int bedeutet ganze Zahl, led ist der Arrayname
                              // Mit den eckigen Klammern hinter led wird angedeutet,
                              // dass es sich um ein Array handelt
int einz=1000;
int ausz=200;
// Damit das Programm flexibel ist, wird hier definiert, was einPegel und ausPegel ist.
// Bei Relais ist  einPegel = LOW, bei LEDs ist einPegel = HIGH
// Dadurch muss man nur diese beiden Zeilen anpassen. Der Rest des Programms bleibt.
int einPegel = LOW;
int ausPegel = HIGH;

void LEDschalten(int lednr, int einz, int ausz) {
  digitalWrite(lednr, einPegel);   // Schalte die LED oder das Relais ein
  delay(einz);                    // Warte, bis die Einschaltzeit (einz) vorbei ist
  digitalWrite(lednr, ausPegel);   // Schalte die LED oder das Relais aus
  delay(ausz);                    // Warte, bis die Ausschaltzeit (ausz) vorbei ist  
}


// the setup routine runs once when you press reset:
void setup() {                
  // initialize the digital pin as an output.
  for (index=0; index<=3; index++ ) {
    pinMode(led[index], OUTPUT);
    digitalWrite(led[index], ausPegel);  // Zu Beginn sind alle LEDs aus
  }
}

// the loop routine runs over and over again forever:
void loop() {
  for (index=0; index<=3; index++ ) {
    LEDschalten(led[index], 980, 000);
    // Jetzt werden alle LEDs fuer 1000 Millisekunden ein, fuer 300 Millisekunden ausgeschaltet.
  }
}
