/*
Messung der Spannung am Analogeingang A0
ohne und mit Spannungsteiler

Ohne Spannungsteiler:
Man schliesst die schwarze Leitung an GND an, die rote an A0
Mit den offenen Enden (rot = +, schwarz = -) beruehrt man die Pole einer Batterie (max. 5V)

Mit Spannungsteiler:
Auf einem Breadboard die in der Anleitung gezeigte Schaltung auf
Die rote Leitung geht zum Pluspol der Batterie, die schwarze zum Minuspol
Maximale Spannung: 50V (fuenfzig Volt)
*/
int wert;
float spannung;

void setup() {
  // put your setup code here, to run once:
  Serial.begin(9600);
  Serial.flush();
}

void loop() {
  wert=analogRead(0);
  
  //Genau eine der folgenden zweiZeilen muss auskommentiert werden, je nach Verwendung. 
  spannung=float(wert)*5/1023;            // Ohne Spannungsteiler aktiv
  //spannung=float(wert)*55/1023;            // Mit Spannungsteiler aktiv
  
  Serial.print("Die Spannung betraegt: ");
  Serial.print(spannung);
  Serial.println( "   Volt");  
  delay(1000);
}
